﻿package {
	import flash.display.Sprite;
	import funnel.*;

	/**
	 * 入力の状態を表示するためのシンプルなスコープクラス
	 * A simple scope class to show changes of inputs.
	 */
	public class SimpleScope extends Sprite {
		private var values:Array;
		private var range:int;
		private var offset:Number;

		public function SimpleScope(x:Number, y:Number, points:int, enableMinus:Boolean=false) {
			super();
			this.x = x;
			this.y = y;
			this.values = new Array(points);
			for (var i:int = 0; i < values.length; i++) {
				values[i] = 0.0;
			}
			if(enableMinus) { range = 50; } else { range = 100; }
			offset = 0;
		}

		public function update(pin:Pin):void {
			updateValue(pin.value);

			offset = (1 - pin.average) * range;
			this.graphics.lineStyle(0.25, 0xFF0000);
			this.graphics.moveTo(x, y + offset);
			this.graphics.lineTo(x + values.length, y + offset);

			offset = (1 - pin.maximum) * range;
			this.graphics.lineStyle(0.25, 0x00FF00);
			this.graphics.moveTo(x, y + offset);
			this.graphics.lineTo(x + values.length, y + offset);

			offset = (1 - pin.minimum) * range;
			this.graphics.lineStyle(0.25, 0x0000FF);
			this.graphics.moveTo(x, y + offset);
			this.graphics.lineTo(x + values.length, y + offset);
		}

		public function updateValue(value:Number):void {
			this.graphics.clear();
			this.graphics.lineStyle(0.25, 0x000000);
			this.graphics.drawRect(x - 2, y - 2, values.length + 4, 100 + 4);
			this.graphics.lineStyle(0.5, 0x000000);
			this.graphics.moveTo(x, y + range);

			values.push(value);
			values.shift();

			for (var i:int = 0; i < values.length; i++) {
				offset = (1 - values[i]) * range;
				this.graphics.lineTo(x + i, y + offset);
			}
		}
	}
}